require "Sketchup.rb"
require "win32/api.rb" #version 1.4.8 for ruby 1.8.x or 1.9.x
include Win32

SetWindowsHookEx=API.new('SetWindowsHookEx', 'IKII', 'I', 'User32') #http://msdn.microsoft.com/en-us/library/ms644990(VS.85).aspx
UnhookWindowsHookEx=API.new('UnhookWindowsHookEx', 'I', 'I', 'User32') #http://msdn.microsoft.com/en-us/library/ms644993(v=VS.85).aspx
GetCurrentThreadId=API.new('GetCurrentThreadId', 'V', 'I', 'Kernel32') #http://msdn.microsoft.com/en-us/library/ms683183(VS.85).aspx
GetModuleHandle=API.new('GetModuleHandle', 'V', 'I', 'Kernel32') #http://msdn.microsoft.com/en-us/library/ms683199(v=VS.85).aspx

$inputText=[nil, [], 0]

def logLine(str, lines=40)
 $inputText[0]=Sketchup.active_model.add_note("Sketchup Hook Procedure", 0.01, 0.2) if ($inputText[0]==nil or $inputText[0].deleted?)
 $inputText[1].push(str)
 $inputText[1][0,($inputText[1].length-lines)]=nil if $inputText[1].length>lines
 $inputText[0].text=$inputText[1].join("\n")
end

class LowLevelMouseHookProc
 @@hhk=nil
 @@lowLevelMouseProc=API::Callback.new("ILP", 'I'){|nCode, wParam, p| #http://msdn.microsoft.com/en-us/library/ms644986(v=VS.85).aspx
  param=[p[0], p[1], p[2], p[3], p[4], p[5], p[6], p[7], p[8], p[9]]
  #MSLLHOOKSTRUCT: http://msdn.microsoft.com/en-us/library/ms644970(v=VS.85).aspx
  x=p[0].to_i + (p[1].to_i<<8) + (p[2].to_i<<16) + (p[3].to_i<<24)
  y=p[4].to_i + (p[5].to_i<<8) + (p[6].to_i<<16) + (p[7].to_i<<24)
  mouseData=p[8].to_i + (p[9].to_i<<8) + (p[10].to_i<<16) + (p[11].to_i<<24)
  $inputText[2]+=1
  logLine("#{$inputText[2]} code: #{nCode} msg: #{wParam} lParam: #{param.inspect} x: #{x} y: #{y} mouseData: #{mouseData}")
  nCode #proccess the message as it states to proccess
 }
 def setHook(hMod=0, threadID=0)
  UnhookWindowsHookEx.call(@@hhk) if @@hhk #First, if exists then unhook the hook before setting it again.
  @@hhk=SetWindowsHookEx.call(14, @@lowLevelMouseProc, hMod, threadID)
 end
 def unhook()
  UnhookWindowsHookEx.call(@@hhk) if @@hhk
  @@hhk=nil
 end
end

class MyAPPObserver < Sketchup::AppObserver #Need to use that because it's highly recommended to unhook the procedure.
 def onQuit() #Will unhook it when sketchup will be closed
  $lowLevelMouseProc.unhook
 end
end

Sketchup.add_observer(MyAPPObserver.new)
$lowLevelMouseProc=LowLevelMouseHookProc.new
threadID=GetCurrentThreadId.call
hMod=GetModuleHandle.call

file_name=File.basename(__FILE__)
unless file_loaded?(file_name)
 $procState=0
 submenu=UI.menu("Plugins")
 item=submenu.add_item("LowLevelMouseHookProc"){
  if $procState==0
   $procState=1
   $lowLevelMouseProc.setHook(hMod) #Since 'lowLevel' stands for global or module handle then it will work only on mudule handle.
  else
   $procState=0
   $lowLevelMouseProc.unhook
   $inputText[0].erase! unless ($inputText[0]==nil or $inputText[0].deleted?)
   $inputText=[nil, [], 0]
  end
 }
 submenu.set_validation_proc(item){if $procState==0 then MF_UNCHECKED else MF_CHECKED end}
 file_loaded(file_name)
end